<template>
  <div>
    <el-row>
      <!--查询-->
      <el-col :span="24">
      <Form
        v-show="searchOpen"
        inline
        onsubmit="return false"
        :label-width="70"
      >
        <label class="label-sign" />
        <Form-item class="search-item" label="模块名称:">
          <el-input v-model="formObj.name" placeholder="请输入模块名称" @keyup.enter.native="_formSearch" clearable/>
        </Form-item>
        <Form-item class="search-item" label="系统:">
          <selectSystem style="width: 100%;" @on-result-change="_systemResult"/>
        </Form-item>
        <Form-item class="search-btn">
          <el-button type="primary" @click="_formSearch">
            搜索
          </el-button>
        </Form-item>
      </Form>
      </el-col>
      <!--操作-->
      <el-col :span="24">
      <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" class="contHide" @on-result-change="_btnClick" />
      </el-col>
      <!-- 表格 -->
      <el-col :span="24">
      <element-table
        ref="pageTable"
        :table-height="tableHeight"
        :get-page="getPage"
        :icon-msg="iconMsg"
        :opt-col-width="70"
        @on-result-change="_tableResultChange"
      >
        <el-table-column
          v-for="item in pageColumns"
          :key="item.id"
          sortable
          show-overflow-tooltip
          :prop="item.key"
          :label="item.title"
          :min-width="item.width"
          :fixed="item.fixed?item.fixed:undefined"
        >
          <template slot-scope="scope">
            <a v-if="item.detail" @click.stop="_detailModal(scope.row.id)">{{ scope.row[item.key] }}</a>
            <div v-else-if="item.key==='status'">
              <div v-if="scope.row.status.value==='NORMAL'" class="blue-color">
                {{ scope.row.status.display }}
              </div>
              <div v-else class="red-color">
                {{ scope.row.status.display }}
              </div>
            </div>
            <div v-else>
              {{ scope.row[item.key] }}
            </div>
          </template>
        </el-table-column>
      </element-table>
      </el-col>
    </el-row>
    <!-- 添加、编辑 -->
    <sysModuleEdit ref="editModal" @on-result-change="_page" />
    <!-- 查看详情 -->
    <sysModuleDetail ref="detailModal" />
  </div>
</template>
<script>
import { sysModule } from '../../../api'
import selectSystem from '../system/selectSystem'
import sysModuleEdit from './sysModuleEdit.vue'
import sysModuleDetail from './sysModuleDetail.vue'

export default {
  components: {
    selectSystem,
    sysModuleEdit,
    sysModuleDetail
  },
  data() {
    return {
      searchOpen: false,
      btn: [{ type: 'success', id: 'sys-module-add', name: '添加' }],
      iconMsg: [{ type: 'pt-edit', id: 'sys-module-edit', name: '编辑' }],
      getPage: {},
      formObj: {
        name: '',
        systemId: ''
      },
      pageColumns: [
        { title: '模块名称', key: 'name', width: 150, detail: true },
        { title: '别名', key: 'alias', width: 100 },
        { title: '状态', key: 'status', width: 100 },
        { title: '图片', key: 'img', width: 100 },
        { title: '排序', key: 'sort', width: 100 },
        { title: '备注', key: 'remark', width: 220 }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._formSearch()
  },
  methods: {
    _systemResult(data) {
      this.formObj.systemId = data
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this._editModal(data.id)
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await sysModule.page(this.$serializeForm(this.formObj))
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _detailModal(id) {
      this.$refs.detailModal._open(id)
    },
    _editModal: async function(id) {
      const result = await sysModule.getById(id)
      this.$refs.editModal._open(result)
    },
    _btnClick(msg) {
      switch (msg) {
        case '添加':
          this.$refs.editModal._open()
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    }
  }
}
</script>
